RuntimeInfrastructure mscorlib [00 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00 ] 1.0.5000.0 2.0.0.0 All public static members of this type are safe for multithreaded operations. No instance members are guaranteed to be thread safe. System.MemberAccessException

Represents the error that occurs when there is an attempt to access a field outside the scope in which access is permitted.

This exception is typically thrown when the access level of a field in a class library is changed, and one or more assemblies referencing the library have not been recompiled.

The following example demonstrates a scenario under which is thrown.

The following code contains a class with a public field (myField). This class is compiled into a class library.

`using System; namespace TestNameSpace { public class Class1 { public Class1() { Console.WriteLine ("Constructing with public field"); } public int myField = -1; } }`

The following code references the class library above, and accesses TestNameSpace.Class1.myField. This code is compiled into an application.

`using System; using TestNameSpace; class AppTest { public static void Main() { Class1 test = new Class1(); Console.WriteLine("Accessing member {0}.", test.myField); } }`

The output of the application is

Constructing with public field

Accessing member -1.

The code for the class library is changed and recompiled so that TestNameSpace.Class1.myField is no longer public. The following code changes myField from public to private.

`using System; namespace TestNameSpace { public class Class1 { public Class1() { Console.WriteLine ("Constructing with private field"); } private int myField = -1; } }`

When the application is executed again without being recompiled, the output is

Unhandled Exception: System.FieldAccessException: TestNameSpace.Class1.myField

at AppTest.Main()

- Constructor

  Constructs and initializes a new instance of the class.

  This constructor initializes the property of the new instance to a system-supplied message that describes the error, such as "Attempted to access a private or protected field inside a type." This message takes into account the current system culture.

  The property of the new instance is initialized to .

  0
  1.0.5000.0
  2.0.0.0
- Constructor
  A that describes the error. The content of is intended to be understood by humans. The caller of this constructor is required to ensure that this string has been localized for the current system culture.

  Constructs and initializes a new instance of the class.

  This constructor initializes the property of the new instance using . If is , the property is initialized to the system-supplied message provided by the constructor that takes no arguments.

  The property of the new instance is initialized to .

  0
  1.0.5000.0
  2.0.0.0
- Constructor
  To be added.
  To be added.
  To be added.
  To be added.
  1.0.5000.0
  2.0.0.0
- Constructor
  A that describes the error. The content of is intended to be understood by humans. The caller of this constructor is required to ensure that this string has been localized for the current system culture.
  An instance of that is the cause of the current exception. If is not a reference, the current exception was raised in a catch block handling .

  Constructs and initializes a new instance of the class.

  This constructor initializes the property of the new instance using and the property using . If is , the property is initialized to the system-supplied message provided by the constructor that takes no arguments.

  For more information on inner exceptions, see .
  0
  1.0.5000.0
  2.0.0.0
0 System.Runtime.InteropServices.ComVisible(true)